From bb9385efa1d895d586c5b44c66b93b3e2a4ffa1c Mon Sep 17 00:00:00 2001
From: Kjell Otto <otto.kjell@gmail.com>
Date: Mon, 11 Mar 2013 13:14:59 +0100
Subject: [PATCH] - Added the --debug parameter to x2goclient.

- Refactored the debugging of "x2goDebug" to contain __FILE__:__LINE__ in order to let users provide more useful informations.

- Added x2goInfof(NUM), x2goWarningf(NUM), x2goErrorf(NUM) to enable parsable outputs for the client.

- Added the show_printouts.sh file to be used for looking into sourcefiles info, warning and error messages. pure convenience here.
---
 .gitignore              |    7 +
 onmainwindow.cpp        |  969 +++++++++++++++++++++++++++++++----------------
 onmainwindow.h          |    3 +
 show_printouts.sh       |   30 ++
 sshmasterconnection.cpp |   88 ++++-
 x2goclientconfig.h      |    2 +-
 x2gologdebug.cpp        |    1 -
 x2gologdebug.h          |   33 +-
 8 files changed, 795 insertions(+), 338 deletions(-)
 create mode 100755 show_printouts.sh

diff --git a/onmainwindow.cpp b/onmainwindow.cpp
index c9741f8..f973014 100644
--- a/onmainwindow.cpp
+++ b/onmainwindow.cpp
@@ -36,18 +36,20 @@ bool	ONMainWindow::portable=false;
 QString ONMainWindow::homeDir;
 QString ONMainWindow::sessionCfg;
 
-
 #ifdef Q_OS_WIN
 QString ONMainWindow::u3Device;
 #endif
 
+bool ONMainWindow::debugging=false;
 
 ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
 {
 #ifdef Q_OS_LINUX
     image=shape=0;
 #endif
-    x2goDebug<<"ONMainWindow constructor"<<endl;
+    x2goInfof(1) << tr("Starting x2goclient...");
+    debugging = false;
+
     setFocusPolicy ( Qt::NoFocus );
     installTranslator();
     cleanAllFiles=false;
@@ -215,8 +217,8 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
             portableDataPath=QDir::currentPath();
 
         homeDir=portableDataPath;
-        x2goDebug<<"running in \"portable\" mode\n"<<
-                 "Data Dir is "<<portableDataPath;
+
+        x2goInfof(2)<<tr("Starting x2goclient in portable mode... data directory is: ")<<portableDataPath;
         QTimer *timer = new QTimer(this);
         connect(timer, SIGNAL(timeout()), this, SLOT(slotCheckPortableDir()));
         timer->start(1000);
@@ -233,7 +235,6 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
     trayIconInit();
 
 
-
     if ( embedMode )
     {
         miniMode=false;
@@ -262,13 +263,11 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
 
     QDesktopWidget wd;
 
-    //x2goDebug<<"primary screen geometry: "<<wd.screenGeometry(wd.screenNumber(this));
-
     if ( wd.screenGeometry(wd.screenNumber(this)).width() <1024 ||
             wd.screenGeometry(wd.screenNumber(this)).height() <768 )
     {
         miniMode=true;
-        x2goDebug<<"Switching to \"mini\" mode";
+        x2goDebug<<"Switching to \"mini\" mode...";
     }
 
 
@@ -383,7 +382,8 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
     initStatusDlg();
 
 #if defined(CFGPLUGIN) && defined(Q_OS_LINUX)
-    x2goDebug<<"create embedContainer"<<endl;
+
+    x2goDebug<<"Creating embedded container.";
     embedContainer=new QX11EmbedContainer ( fr );
 
 #endif
@@ -449,9 +449,11 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
 
     connect( xineramaTimer, SIGNAL(timeout()), this, SLOT(slotConfigXinerama()));
 
-    x2goDebug<<"ONMainWindows constructor finished, home Directory is:"<<homeDir<<endl;
+    x2goInfof(3)<<tr("Started  x2goclient.");
+    x2goDebug<<"$HOME=" + homeDir.toAscii();
     if (thinMode)
     {
+        x2goDebug<<"ThinMode is active.";
         showMaximized();
         activateWindow();
         raise();
@@ -461,10 +463,10 @@ ONMainWindow::ONMainWindow ( QWidget *parent ) :QMainWindow ( parent )
 
 ONMainWindow::~ONMainWindow()
 {
-    x2goDebug<<"ONMainWindow destructor";
+    x2goDebug<<"Destroying x2goclient...";
     if ( !closeEventSent )
         closeClient();
-    x2goDebug<<"end of ONMainWindow destructor";
+    x2goDebug<<"Destroyed  x2goclient.";
 }
 
 void ONMainWindow::slotShutdownThinClient()
@@ -509,13 +511,12 @@ void ONMainWindow::installTranslator()
     filename=filename.toLower();
     if ( !x2goclientTranslator->load ( filename ) )
     {
-        qDebug ( "Can't load translator (%s) !\n",
-                 filename.toLocal8Bit().data() );
+        x2goWarningf(1)<<tr("Can't load translator: ") + filename.toAscii();
     }
     else
     {
         QCoreApplication::installTranslator ( x2goclientTranslator );
-// 		x2goDebug<<"translator "<<filename<< " installed";
+        x2goInfof(4)<<tr("Translator: ") + filename.toAscii() + tr(" installed.");
     }
 
 
@@ -523,13 +524,12 @@ void ONMainWindow::installTranslator()
     filename=QString ( ":/qt_%1" ).arg ( QLocale::system().name() );
     if ( !qtTranslator->load ( filename ) )
     {
-        x2goDebug<< "Can't load translator "<<
-                 filename.toLocal8Bit().data() ;
+        x2goWarningf(2)<<tr("Can't load translator: ") + filename.toAscii();
     }
     else
     {
         QCoreApplication::installTranslator ( qtTranslator );
-// 		x2goDebug<<"translator "<<filename<< " installed";
+        x2goInfof(5)<<tr("Translator: ") + filename.toAscii() + tr(" installed.");
     }
 }
 
@@ -646,6 +646,7 @@ void ONMainWindow::initWidgetsEmbed()
     if ( config.confFS&& ( !config.useFs ) )
     {
         x2goDebug<<"hide share";
+
         act_shareFolder->setVisible ( false );
     }
 
@@ -907,7 +908,8 @@ void ONMainWindow::slotTestConnection()
 
 void ONMainWindow::slotChangeBrokerPass()
 {
-    x2goDebug<<"change broker pass";
+    x2goDebug<<"Changing broker password.";
+
     BrokerPassDlg passDlg;
     if (passDlg.exec()!=QDialog::Accepted)
         return;
@@ -930,7 +932,7 @@ void ONMainWindow::slotCheckPortableDir()
 {
     if (!QFile::exists(homeDir))
     {
-        x2goDebug<<"portable dir not exists, close";
+        x2goDebug<<"Portable directory does not exists, closing.";
         close();
     }
 }
@@ -1077,8 +1079,12 @@ void ONMainWindow::trayIconInit()
             trayIcon->setIcon(QIcon ( ":icons/128x128/x2go.png") );
             trayIcon->setToolTip(tr("Left mouse button to hide/restore - Right mouse button to display context menu"));
         }
-        trayIcon->show();
-        plugAppsInTray();
+
+        if (!startHidden)
+        {
+            trayIcon->show();
+            plugAppsInTray();
+        }
     }
 #endif
 }
@@ -1093,7 +1099,8 @@ QMenu* ONMainWindow::initTrayAppMenu(QString text, QPixmap icon)
 
 void ONMainWindow::slotAppMenuTriggered(QAction* action)
 {
-    x2goDebug<<"slotAppMenuTriggered :"<<action->data().toString()<<endl;
+    x2goDebug<<"slotAppMenuTriggered: "<<action->data().toString();
+
     if (action->data().toString() != "")
         runApplication(action->data().toString());
 }
@@ -1103,7 +1110,9 @@ void ONMainWindow::plugAppsInTray()
     if (!trayIcon)
         return;
     removeAppsFromTray();
-    x2goDebug<<"plugging apps\n";
+
+    x2goDebug<<"Plugging apps in tray.";
+
     bool empty=true;
     topActions.clear();
     foreach(Application app, applications)
@@ -1133,7 +1142,9 @@ void ONMainWindow::removeAppsFromTray()
 {
     if (!trayIcon)
         return;
-    x2goDebug<<"remove apps\n";
+
+    x2goDebug<<"Removing apps from tray";
+
     for (int i=0; i<=Application::OTHER; ++i)
     {
         appMenu[i]->clear();
@@ -1237,13 +1248,13 @@ void ONMainWindow::slotResize ( const QSize sz )
 
 void ONMainWindow::closeClient()
 {
+    x2goInfof(6)<<tr("Closing x2goclient...");
     if(trayIcon)
         trayIcon->hide();
     closeEventSent=true;
     if ( !startMaximized && !startHidden && !embedMode )
     {
-        x2goDebug<<"saving settings";
-
+        x2goDebug<<"Saving settings...";
         X2goSettings st ( "sizes" );
 
         st.setting()->setValue ( "mainwindow/size",
@@ -1252,7 +1263,7 @@ void ONMainWindow::closeClient()
         st.setting()->setValue ( "mainwindow/maximized",
                                  QVariant ( isMaximized() ) );
         st.setting()->sync();
-        x2goDebug<<"done";
+        x2goDebug<<"Saved  settings.";
 #ifdef Q_OS_LINUX
         if (image)
             XFreePixmap(QX11Info::display(),image);
@@ -1264,20 +1275,19 @@ void ONMainWindow::closeClient()
     {
         if ( nxproxy->state() ==QProcess::Running )
         {
-            x2goDebug<<"terminate proxy";
+            x2goDebug<<"Terminating proxy...";
             nxproxy->terminate();
-            x2goDebug<<"done";
+            x2goDebug<<"Terminated  proxy.";
         }
-        x2goDebug<<"delete proxy process";
+        x2goDebug<<"Deleting proxy...";
         delete nxproxy;
-        x2goDebug<<"done";
-
+        x2goDebug<<"Deleted  proxy.";
     }
     if ( sshConnection && !useLdap)
     {
-        x2goDebug<<"waiting sshConnection to finish\n";
+        x2goDebug<<"Waiting for the SSH connection to finish...";
         delete sshConnection;
-        x2goDebug<<"sshConnection is closed\n";
+        x2goDebug<<"Waited  for the SSH connection to finish.";
         sshConnection=0;
     }
     if (useLdap)
@@ -1286,51 +1296,29 @@ void ONMainWindow::closeClient()
         {
             if (serverSshConnections[i])
             {
-                x2goDebug<<"waiting sshConnection to finish\n";
+                x2goDebug<<"Waiting for the SSH connection to finish...";
                 delete serverSshConnections[i];
-                x2goDebug<<"sshConnection is closed\n";
+                x2goDebug<<"Waited  for the SSH connection to finish.";
             }
         }
     }
 
-    /*	if ( tunnel!=0l )
-    	{
-    		x2goDebug<<"delete tunnel";
-    		delete tunnel;
-    		x2goDebug<<"done";
-    	}
-    	if ( sndTunnel!=0l )
-    	{
-    		x2goDebug<<"delete snd tunnel";
-    		delete sndTunnel;
-    		x2goDebug<<"done";
-    	}
-    	if ( fsTunnel!=0l )
-    	{
-    		x2goDebug<<"delete fs tunnel";
-    		delete fsTunnel;
-    		x2goDebug<<"done";
-    	}
-    	*/
     if ( soundServer )
     {
-        x2goDebug<<"delete snd server";
+        x2goDebug<<"Deleting the sound server...";
         delete soundServer;
-        x2goDebug<<"done";
+        x2goDebug<<"Deleted  the sound server.";
     }
     if ( gpgAgent!=0l )
     {
-        x2goDebug<<"terminate gpg-agent";
         if ( gpgAgent->state() ==QProcess::Running )
+        {
+            x2goDebug<<"Terminating gpg-agent...";
             gpgAgent->terminate();
-        x2goDebug<<"done";
-    }
-    /*	if ( useSshAgent )
-    	{
-    		x2goDebug<<"terminate ssh-agent";
-    		finishSshAgent();
-    		x2goDebug<<"done";
-    	}*/
+            x2goDebug<<"Terminated  gpg-agent.";
+        }
+    }
+
 #ifndef Q_OS_WIN
     if ( agentPid.length() >0 )
     {
@@ -1345,13 +1333,15 @@ void ONMainWindow::closeClient()
 #ifdef Q_OS_WIN
     if ( pulseServer )
     {
+        x2goDebug<<"Deleting the pulse timer...";
         delete pulseTimer;
-
-        x2goDebug<<"terminate pulse";
+        x2goDebug<<"Deleted  the pulse timer.";
+        x2goDebug<<"Killing the pulse sound server...";
         pulseServer->kill();
-        x2goDebug<<"done\ndelete pulse process";
+        x2goDebug<<"Killed  the pulse sound server.";
+        x2goDebug<<"Deleting the pulse process...";
         delete pulseServer;
-        x2goDebug<<"done";
+        x2goDebug<<"Deleted  the pulse process.";
 
         QDir dr ( homeDir );
         dr.remove ( pulseDir+"/config.pa" );
@@ -1361,11 +1351,12 @@ void ONMainWindow::closeClient()
     }
     if ( xorg )
     {
-        x2goDebug<<"terminate xorg";
+        x2goDebug<<"Terminating xorg...";
         xorg->terminate();
-        x2goDebug<<"done\ndelete xorg process";
+        x2goDebug<<"Terminated  xorg.";
+        x2goDebug<<"Deleting xorg...";
         delete xorg;
-        x2goDebug<<"done";
+        x2goDebug<<"Deleted xorg.";
     }
 
     if ( winSshdStarted )
@@ -1377,8 +1368,9 @@ void ONMainWindow::closeClient()
 #else
     if ( userSshd && sshd )
     {
+        x2goDebug<<"Terminating sshd...";
         sshd->terminate();
-        x2goDebug<<"terminating userspace sshd";
+        x2goDebug<<"Terminated  sshd.";
         delete sshd;
     }
 
@@ -1407,11 +1399,14 @@ void ONMainWindow::closeClient()
         cleanPortable();
     }
     SshMasterConnection::finalizeLibSsh();
+
+    x2goInfof(7)<<tr("Closed  x2goclient.");
 }
 
 void ONMainWindow::closeEvent ( QCloseEvent* event )
 {
-    x2goDebug<<"close event";
+    x2goDebug<<"Close event received.";
+
     if (trayNoclose && !brokerMode)
     {
         hide();
@@ -1574,7 +1569,9 @@ void ONMainWindow::displayUsers()
     if ( usePGPCard  && !PGPInited)
     {
         PGPInited=true;
-        x2goDebug<<"Users loaded, starting smart card daemon\n";
+
+        x2goDebug<<"Users loaded, starting smart card daemon.";
+
         QTimer::singleShot ( 10, this, SLOT ( slotStartPGPAuth() ) );
     }
 }
@@ -1734,8 +1731,8 @@ void ONMainWindow::slotPassEnter()
         {
             sPort=sL.front().c_str();
         }
-        x2goDebug<<server.name<<": ssh port is "<<sPort;
 
+        x2goDebug<<"SSH-Server("<<server.name<<") port: "<<sPort;
 
         QString sFactor="1";
         list<string> serialNumber=LDAPSession::getStringAttrValues (
@@ -1744,7 +1741,9 @@ void ONMainWindow::slotPassEnter()
         {
             sFactor=serialNumber.front().c_str();
         }
-        x2goDebug<<server.name<<": factor is "<<sFactor;
+
+        x2goDebug<<"SSH-Server("<<server.name<<") factor: "<<sFactor;
+
         server.factor=sFactor.toFloat();
         server.sess=0;
         server.sshPort=sPort;
@@ -2140,10 +2139,16 @@ void ONMainWindow::slotReadSessions()
         st= new X2goSettings( "sessions" );
 
     QStringList slst=st->setting()->childGroups();
-    x2goDebug<<"read "<<slst.size()<<" sessions from config file";
+
+    x2goDebug<<"Reading "<<slst.size()<<" sessions from config file.";
+
     if (brokerMode && (slst.size()==0))
     {
-        QMessageBox::critical(this,tr("Error"),tr("X2Go sessions not found"));
+        QString error = tr("No X2Go sessions found, closing.");
+        if(!startHidden)
+            QMessageBox::critical(this,tr("Error"),error);
+        else
+            x2goErrorf(1)<<error; // tr("No X2Go sessions not found, closing.");
         close();
         return;
     }
@@ -2329,7 +2334,9 @@ void ONMainWindow::displayToolBar ( bool show )
 bool ONMainWindow::initLdapSession ( bool showError )
 {
 #ifdef USELDAP
-    x2goDebug<<"initing LDAP Session"<<endl;
+
+    x2goDebug<<"Initializing LDAP sessions...";
+
     try
     {
         ld=new LDAPSession ( ldapServer.toStdString(),
@@ -2340,7 +2347,9 @@ bool ONMainWindow::initLdapSession ( bool showError )
         QString message="Exeption0 in: ";
         message=message+e.err_type.c_str();
         message=message+" : "+e.err_str.c_str();
-        x2goDebug <<message<<endl;
+
+        x2goDebug<<message;
+
         if ( ldapServer1.length() )
         {
             try
@@ -2354,7 +2363,9 @@ bool ONMainWindow::initLdapSession ( bool showError )
                 QString message="Exeption1 in: ";
                 message=message+e.err_type.c_str();
                 message=message+" : "+e.err_str.c_str();
-                x2goDebug <<message<<endl;
+
+                x2goDebug<<message;
+
                 if ( ldapServer2.length() )
                 {
                     try
@@ -2372,8 +2383,8 @@ bool ONMainWindow::initLdapSession ( bool showError )
                                 e.err_type.c_str();
                         message=message+" : "+
                                 e.err_str.c_str();
-                        x2goDebug <<message<<endl;
-                        x2goDebug<<"return false"<<endl;
+
+                        x2goDebug<<message;
                         if ( showError )
                             QMessageBox::critical (
                                 0l,tr ( "Error" ),
@@ -2382,12 +2393,14 @@ bool ONMainWindow::initLdapSession ( bool showError )
                                 QMessageBox::
                                 NoButton );
 
+                        x2goDebug<<"Returning false, 3rd try failed.";
                         return false;
                     }
                 }
                 else
                 {
-                    x2goDebug<<"return false"<<endl;
+                    x2goDebug<<"Returning false.";
+
                     if ( showError )
                         QMessageBox::critical (
                             0l,tr ( "Error" ),
@@ -2401,7 +2414,8 @@ bool ONMainWindow::initLdapSession ( bool showError )
         }
         else
         {
-            x2goDebug<<"return false"<<endl;
+            x2goDebug<<"Returning false.";
+
             if ( showError )
                 QMessageBox::critical ( 0l,tr ( "Error" ),
                                         message,QMessageBox::Ok,
@@ -2531,6 +2545,7 @@ bool ONMainWindow::initLdapSession ( bool showError )
         }
     }
 #endif
+    x2goDebug<<"Initialized  LDAP sessions.";
     return true;
 
 }
@@ -2723,7 +2738,7 @@ void ONMainWindow::slotSelectedFromList ( SessionButton* session )
     }
     if ( currentKey != QString::null && currentKey != "" && nopass )
     {
-        x2goDebug<<"Have key, starting session"<<endl;
+        x2goDebug<<"Starting session with key.";
         slotSessEnter();
     }
     if ( cardReady || autologin || krblogin  )
@@ -2758,17 +2773,20 @@ SshMasterConnection* ONMainWindow::startSshConnection ( QString host, QString po
         QString proxylogin, QString proxypassword, QString proxyKey,
         bool proxyAutologin)
 {
-
+    x2goInfof(8)<<tr("Starting connection to server: ") + host + ":" + port;
     SshMasterConnection* con;
-    x2goDebug<<"start new ssh connection to server:"<<host<<":"<<port<<"krb: "<<krbLogin<<endl;
+
+    x2goDebug<<"Start new ssh connection to server:"<<host<<":"<<port<<" krbLogin: "<<krbLogin;
+
     for ( int i=0; i<sshEnv.size(); ++i )
     {
 #ifndef Q_OS_WIN
         QStringList args=sshEnv[i].split ( "=" );
-        x2goDebug<<"set Env "<<args[0]<<" to "<<args[1]<<endl;
+        x2goDebug<<"Setting ENV " + args[0] + tr(" to ") + args[1];
         setenv ( args[0].toAscii(),args[1].toAscii(),1 );
 #else
-        x2goDebug<<"set Env "<<sshEnv[i]<<endl;
+        x2goDebug<<"Set ENV: "<<sshEnv[i];
+
         _putenv ( sshEnv[i].toAscii() );
 #endif
     }
@@ -2809,6 +2827,7 @@ SshMasterConnection* ONMainWindow::startSshConnection ( QString host, QString po
 
 void ONMainWindow::slotSshConnectionError ( QString message, QString lastSessionError )
 {
+    x2goErrorf(2)<< tr("Connection Error(") + message + "): " + lastSessionError;
     if ( sshConnection )
     {
         sshConnection->wait();
@@ -2816,26 +2835,35 @@ void ONMainWindow::slotSshConnectionError ( QString message, QString lastSession
         sshConnection=0l;
     }
 
-    QMessageBox::critical ( 0l,message,lastSessionError,
-                            QMessageBox::Ok,
-                            QMessageBox::NoButton );
-    setEnabled ( true );
-    passForm->setEnabled ( true );
-    slotShowPassForm();
-    pass->setFocus();
-    pass->selectAll();
+    if (!startHidden)
+    {
+        QMessageBox::critical ( 0l,message,lastSessionError,
+                                QMessageBox::Ok,
+                                QMessageBox::NoButton );
+        setEnabled ( true );
+        passForm->setEnabled ( true );
+        slotShowPassForm();
+        pass->setFocus();
+        pass->selectAll();
 
 
-    passForm->setEnabled ( true );
-    if ( startHidden )
+        passForm->setEnabled ( true );
+    }
+    else
     {
-        startHidden=false;
-        slotResize();
-        show();
-        activateWindow();
-        raise();
+        // In order to get this interaction free, we need to free this from windows and stuff
+        //    if ( startHidden )
+        //    {
+        //        startHidden=false;
+        //        slotResize();
+        //        show();
+        //        activateWindow();
+        //        raise();
+        //    }
+
+        // completely quit the application
+        trayQuit();
     }
-
 }
 
 
@@ -2843,7 +2871,7 @@ void ONMainWindow::slotSshConnectionError ( QString message, QString lastSession
 
 void ONMainWindow::slotSshConnectionOk()
 {
-    x2goDebug<<"ssh connection ok"<<endl;
+    x2goDebug<<"SSH connection established.";
     passForm->setEnabled ( true );
     if ( useLdap )
     {
@@ -2856,14 +2884,19 @@ void ONMainWindow::slotSshConnectionOk()
 
 SshMasterConnection*  ONMainWindow::findServerSshConnection(QString host)
 {
+    x2goDebug<<"Searching for SSH connections...";
     for (int i=0; i<serverSshConnections.count(); ++i)
     {
         if (serverSshConnections[i])
         {
             if (serverSshConnections[i]->getHost()==host)
+            {
+                x2goDebug<<"Found SSH connection.";
                 return serverSshConnections[i];
+            }
         }
     }
+    x2goWarningf(3)<< tr("Couldn't find a SSH connection.");
     return 0l;
 }
 
@@ -2872,7 +2905,7 @@ void ONMainWindow::slotServSshConnectionOk(QString server)
     SshMasterConnection* con=findServerSshConnection(server);
     if (!con)
         return;
-    x2goDebug<<"getting sessions on "<<server<<endl;
+    x2goDebug<<"Getting sessions on Host: " + server;
     con->executeCommand( "export HOSTNAME && x2golistsessions", this, SLOT (slotListAllSessions ( bool,QString,int ) ));
 }
 
@@ -2989,6 +3022,21 @@ void ONMainWindow::slotSshUserAuthError ( QString error )
         sshConnection=0l;
     }
 
+    //    if ( startHidden )
+    //    {
+    //        startHidden=false;
+    //        slotResize();
+    //        show();
+    //        activateWindow();
+    //        raise();
+    //    }
+    // hidden means hidden, we'll close the client afterwards.
+    if ( startHidden )
+    {
+        x2goErrorf(3)<< tr("Authentication failed: ") + error;
+        trayQuit();
+    }
+
     QMessageBox::critical ( 0l,tr ( "Authentication failed" ),error,
                             QMessageBox::Ok,
                             QMessageBox::NoButton );
@@ -3001,14 +3049,6 @@ void ONMainWindow::slotSshUserAuthError ( QString error )
 
 
     passForm->setEnabled ( true );
-    if ( startHidden )
-    {
-        startHidden=false;
-        slotResize();
-        show();
-        activateWindow();
-        raise();
-    }
 }
 
 void ONMainWindow::slotSessEnter()
@@ -3023,7 +3063,8 @@ void ONMainWindow::slotSessEnter()
     {
         if (!config.brokerAuthenticated)
         {
-            x2goDebug<<"starting broker request";
+
+            x2goDebug<<"Starting broker request.";
             slotStartBroker();
             return;
         }
@@ -3056,7 +3097,7 @@ void ONMainWindow::slotSessEnter()
 
 void ONMainWindow::continueNormalSession()
 {
-    x2goDebug<<"continue normal x2go session"<<endl;
+    x2goDebug<<"Continue normal x2go session";
     if (brokerMode)
     {
         slotListSessions(true,QString::null,0);
@@ -3248,7 +3289,8 @@ bool ONMainWindow::startSession ( const QString& sid )
     if(brokerMode)
     {
         sshPort=config.sshport;
-        x2goDebug<<"server: "<<host;
+
+        x2goDebug<<"Server: "<<host;
     }
 
     QString cmd=st->setting()->value ( sid+"/command",
@@ -3399,9 +3441,24 @@ void ONMainWindow::slotListSessions ( bool result,QString output,
                     message;
         }
 
-        QMessageBox::critical ( 0l,tr ( "Error" ),message,
-                                QMessageBox::Ok,
-                                QMessageBox::NoButton );
+        if ( !startHidden )
+        {
+            QMessageBox::critical ( 0l,tr ( "Error" ),message,
+                                    QMessageBox::Ok,
+                                    QMessageBox::NoButton );
+        }
+        else
+        {
+            QString printout = tr( "Connection failed: ")  + output.toAscii();
+
+            if ( output.indexOf ( "publickey,password" ) !=-1 )
+                x2goErrorf(4)<< tr( "Connection failed: ")  + output + tr(" - Wrong password.");
+            else
+                x2goErrorf(5)<< tr( "Connection failed: ")  + output;
+            trayQuit();
+        }
+
+
 // 		currentKey=QString::null;
         setEnabled ( true );
         passForm->setEnabled ( true );
@@ -3420,17 +3477,16 @@ void ONMainWindow::slotListSessions ( bool result,QString output,
     }
     if ( managedMode || brokerMode )
     {
-        x2goDebug<<"sess data:"<<config.sessiondata;
+        x2goDebug<<"Session data: " + config.sessiondata;
         if ( config.sessiondata.indexOf ( "|S|" ) ==-1 )
         {
-            x2goDebug<<"start new managed session";
+            x2goDebug<<"Starting new managed session.";
             startNewSession();
         }
         else
         {
-            x2goSession s=getSessionFromString (
-                              config.sessiondata );
-            x2goDebug<<"resuming managed session:"<<s.sessionId;
+            x2goSession s=getSessionFromString (config.sessiondata);
+            x2goDebug<<"Resuming managed session with Id: " + s.sessionId;
             resumeSession ( s );
         }
         return;
@@ -3718,7 +3774,9 @@ void ONMainWindow::startNewSession()
 
     QString geometry;
 #ifdef Q_OS_WIN
-    x2goDebug<<"fullscreen: "<<fullscreen;
+
+    x2goDebug<<"Fullscreen: "<<fullscreen;
+
     maximizeProxyWin=false;
     proxyWinWidth=width;
     proxyWinHeight=height;
@@ -3740,7 +3798,9 @@ void ONMainWindow::startNewSession()
 #ifdef Q_OS_WIN
 //        fullscreen=false;
         maximizeProxyWin=true;
-        x2goDebug<<"maximizeProxyWin: "<<maximizeProxyWin;
+
+        x2goDebug<<"Maximize proxy win: "<<maximizeProxyWin;
+
 #endif
     }
     if ( ! fullscreen )
@@ -3843,7 +3903,9 @@ void ONMainWindow::startNewSession()
              shadowUser+"XSHAD"+shadowDisplay;
     }
     resumingSession.fullscreen=fullscreen;
-    x2goDebug<<cmd<<endl;
+
+    x2goDebug<<"Executing remote command: "<<cmd;
+
     if ( managedMode )
     {
         slotRetResumeSess ( true,config.sessiondata,0 );
@@ -4007,7 +4069,8 @@ void ONMainWindow::resumeSession ( const x2goSession& s )
 #ifdef Q_OS_WIN
 //        fullscreen=false;
         maximizeProxyWin=true;
-        x2goDebug<<"maximizeProxyWin: "<<maximizeProxyWin;
+
+        x2goDebug<<"Maximize proxy win: "<<maximizeProxyWin;
 
 #endif
     }
@@ -4098,10 +4161,10 @@ void ONMainWindow::selectSession ( QStringList& sessions )
     setEnabled ( true );
     sessionStatusDlg->hide();
     passForm->hide();
-// 	x2goDebug<<"check type";
+
     if ( !shadowSession )
     {
-// 		x2goDebug<<"! shadow";
+        x2goDebug<<"No shadow session.";
         if ( !miniMode )
             selectSesDlgLayout->setContentsMargins ( 25,25,10,10 );
 
@@ -4110,13 +4173,13 @@ void ONMainWindow::selectSession ( QStringList& sessions )
         bTerm->show();
         sOk->show();
         sCancel->show();
-// 		x2goDebug<<"standart buttons ok";
+
         desktopFilter->hide();
         desktopFilterCb->hide();
         bShadow->hide();
         bShadowView->hide();
         bCancel->hide();
-// 		x2goDebug<<"shadow buttons ok";
+
 // 		model->clear();
         model->removeRows ( 0,model->rowCount() );
         selectSessionLabel->setText ( tr ( "Select session:" ) );
@@ -4124,10 +4187,9 @@ void ONMainWindow::selectSession ( QStringList& sessions )
         QFontMetrics fm ( sessTv->font() );
         for ( int row = 0; row < sessions.size(); ++row )
         {
-
-// 			x2goDebug<<"decoding sessionstr:"<<sessions[row];
+            x2goDebug<<"Decoding Sessionstring:" + sessions[row];
             x2goSession s=getSessionFromString ( sessions[row] );
-// 			x2goDebug<<"listing id:"<<s.sessionId;
+
             selectedSessions.append ( s );
             QStandardItem *item;
 
@@ -4412,13 +4474,18 @@ void ONMainWindow::slotTermSessFromSt()
 #ifdef Q_OS_LINUX
     if (directRDP)
     {
-        x2goDebug<<"terminating direct RDP session";
+
+        x2goDebug<<"Terminating direct RDP session.";
+
         nxproxy->terminate();
         proxyRunning=false;
         return;
     }
 #endif
-    /*	x2goDebug <<"disconnect export"<<endl;
+
+    x2goDebug<<"Disconnect export.";
+
+    /*
     	disconnect ( sbExp,SIGNAL ( clicked() ),this,
     	             SLOT ( slot_exportDirectory() ) );*/
     sbExp->setEnabled ( false );
@@ -4560,7 +4627,9 @@ void ONMainWindow::slotRetResumeSess ( bool result,
                                        QString output,
                                        int )
 {
-    x2goDebug<<"Agent output:"<<output;
+
+    x2goDebug<<"Agent output: "<<output;
+
     if ( result==false )
     {
         QString message=tr ( "<b>Connection failed</b>\n" ) +output;
@@ -4716,17 +4785,23 @@ void ONMainWindow::slotRetResumeSess ( bool result,
             if (line.indexOf("gr_port=")!=-1)
             {
                 resumingSession.grPort=line.replace("gr_port=","");
-                x2goDebug<<"new gr_port: "<<resumingSession.grPort<<endl;
+
+                x2goDebug<<"New gr_port: "<<resumingSession.grPort;
+
             }
             if (line.indexOf("sound_port=")!=-1)
             {
                 resumingSession.sndPort=line.replace("sound_port=","");
-                x2goDebug<<"new sound_port: "<<resumingSession.sndPort<<endl;
+
+                x2goDebug<<"New sound_port: "<<resumingSession.sndPort;
+
             }
             if (line.indexOf("fs_port=")!=-1)
             {
                 resumingSession.fsPort=line.replace("fs_port=","");
-                x2goDebug<<"new fs_port: "<<resumingSession.fsPort<<endl;
+
+                x2goDebug<<"New fs_port: "<<resumingSession.fsPort;
+
             }
         }
         if (resumingSession.published)
@@ -4827,13 +4902,13 @@ void ONMainWindow::slotRetResumeSess ( bool result,
             }
 #endif
             if ( sysPulse )
-
+            {
                 sshConnection->copyFile(
                     "/var/run/pulse/.pulse-cookie",
                     "~/.x2go/C-"+
                     resumingSession.sessionId+
                     "/.pulse-cookie", this, SLOT ( slotPCookieReady ( bool, QString,int )));
-
+            }
             else
             {
 #ifndef Q_OS_WIN
@@ -4938,7 +5013,9 @@ void ONMainWindow::slotTunnelOk(int)
     //waiting for X
     if ( !winServersReady )
     {
-        x2goDebug<<"waiting for win-servers";
+
+        x2goDebug<<"Waiting for win-servers.";
+
         QTimer::singleShot ( 100, this, SLOT ( slotTunnelOk() ) );
         return;
     }
@@ -4951,9 +5028,13 @@ void ONMainWindow::slotTunnelOk(int)
     if ( !d.exists() )
         if ( !d.mkpath ( dirpath ) )
         {
-            QString message=tr ( "Unable to create folder:" ) +
-                            dirpath;
-            QMessageBox::critical ( 0l,tr ( "Error" ),message,
+            if (startHidden)
+            {
+                x2goErrorf(6)<< tr( "Unable to create folder: ")  + dirpath;
+                trayQuit();
+            }
+
+            QMessageBox::critical ( 0l,tr ( "Error" ), tr ( "Unable to create folder: " ) + dirpath,
                                     QMessageBox::Ok,
                                     QMessageBox::NoButton );
             slotShowPassForm();
@@ -4977,9 +5058,13 @@ void ONMainWindow::slotTunnelOk(int)
     QFile file ( dirpath+"/options" );
     if ( !file.open ( QIODevice::WriteOnly | QIODevice::Text ) )
     {
-        QString message=tr ( "Unable to write file:" ) +
-                        dirpath+"/options";
-        QMessageBox::critical ( 0l,tr ( "Error" ),message,
+        if (startHidden)
+        {
+            x2goErrorf(7)<< tr( "Unable to write file: " ) + dirpath + "/options";
+            trayQuit();
+        }
+
+        QMessageBox::critical ( 0l,tr ( "Error" ), tr( "Unable to write file: " ) + dirpath + "/options",
                                 QMessageBox::Ok,
                                 QMessageBox::NoButton );
         slotShowPassForm();
@@ -5010,6 +5095,7 @@ void ONMainWindow::slotTunnelOk(int)
     for ( int l=0; l<env.size(); ++l )
     {
 // 		x2goDebug<<env[l]<<endl;
+
         if ( env[l].indexOf ( "X2GO_LIB" ) ==0 )
         {
             x2golibpath=env[l].split ( "=" ) [1];
@@ -5039,13 +5125,17 @@ void ONMainWindow::slotTunnelOk(int)
     if ( dispInd==-1 )
     {
         env <<"DISPLAY=localhost:"+disp;
+
         /*		x2goDebug<<"new env DISPLAY"<<"DISPLAY=localhost:"+disp<<endl;*/
+
     }
     else
     {
         env[dispInd]="DISPLAY=localhost:"+disp;
+
         /*		x2goDebug<<"existing env DISPLAY("<<dispInd<<
         		") DISPLAY=localhost:"+disp<<endl;*/
+
     }
 #endif // Q_OS_WIN
 #if defined ( Q_OS_DARWIN )
